dnl  Copyright 1999 by Donn Cave, Seattle, Washington, USA.
dnl  All rights reserved.  Permission to copy, modify and distribute this
dnl  material is hereby granted, without fee, provided that the above
dnl  copyright notice appear in all copies.

//
//  C++ code automatically generated.
//
#include <stdio.h>
#include <string.h>

includes(BE_INCLUDES)

dnl  Virtual functions need be_app, to quit if something goes wrong.
dnl
ifdef(`VFUNS',``#'include <app/Application.h>')

`#'include <Python.h>
`#'include "PyBase.h"
`#'include "PyMisc.h"

imports(IMPORTS)

`#'include "BpyBase.h"
ifdef(`VFUNS',
`// Class has virtual methods - e.g., handler.
enum {
   venums(VFUNS)
   NVFN
};
//
')

static PyObject *ECLASS;

dnl Inheritance scheme for C++ classes derived from Be API for Python:
dnl  "var"  just Be API class. (Obsolete?)
dnl  "ref"  add 4-byte tag to identify Python-internal objects, & ptr.
dnl         "VFUNS"  has virtual functions, from Python instance wrapper.
dnl                  "handler"  not "looper", but has Looper() function.
dnl                  "looper"   has its own Python thread.
dnl                             "BApplication" special looper.
dnl
dnl  "var" vs. "ref" basically revolves around the FromIt function
dnl  (e.g., PyBHandler_FromBHandler() - this function gets a pointer
dnl  to a C object and wraps it up in a Python C object.)  It might
dnl  copy the C object, which would be the normal case ("var"), but
dnl  many C objects wouldn't take well to that - a BLooper, for example,
dnl  so we'll want a Python reference to that very C object.  In this
dnl  case, Python just needs to know that it should only delete the
dnl  C object, when it created it.  This distinction is recorded in
dnl  the C object (because that's what FromIt gets), along with a pointer
dnl  back to the Python C object.  When the stamp is recognized, FromIt
dnl  returns the same Python C object.  For an example - the DispatchMessage
dnl  virtual hook gets a BHandler, and needs to convert that to a PyBHandler
dnl  for its Python function.  Since the system accepts external objects,
dnl  not created here, we may point to either our derived class, or the
dnl  plain Be base class, and use a variety of hacks to distinguish.
dnl
dnl  Support for virtual functions adds a table for callbacks into the
dnl  Python class instance wrapper, and thread interfaces.  The derived
dnl  class for this instantiates each supported virtual function, and
dnl  if it's not actually provided in the wrapper, calls the base class
dnl  function and returns.
dnl
dnl  These callbacks need to be integrated with Python threads.  The
dnl  model for that here is one thread per looper, and all callbacks
dnl  use their looper's thread (objects that are not themselves loopers
dnl  can call Looper() to get the thread looper.)  This model leaves
dnl  a few things out, e.g., BFilePanel/BRefFilter callbacks aren't
dnl  looking like they're going to work out at this point.  A few hook
dnl  functions get BView etc. parameters that can be used to find the
dnl  thread looper (see "looperhandler" in .dx files), but we need either
dnl  this or Handler/Looper parentage; otherwise, can't find thread state,
dnl  can't branch into Python.
dnl
dnl  Meanwhile, the Python object also has base class issues, because
dnl  a BListView for example needs to be accepted as a BView in Python
dnl  function calls just as in C++.  This happens in the AsIt function,
dnl  which goes about it in whatever funky way - once it has determined
dnl  that the object is of the BaseObject variety, via another one of
dnl  these hacky stamps.

define(`SEMANTICS', ifelse(FROMSELF, `var', `var', `ref'))
ifdef(`VFUNS',
   `ifelse(FROMSELF, `looper',
      `define(`VECLASS', `BpyLVBase')
       define(`looperspec')',
      `define(`VECLASS', `BpyHVBase')
       define(`looperspec', `$1')
       ifelse(FROMSELF, `handler',, `define(`looperless')')'
    )',
   `define(`VECLASS', `BpyBase')'
)

ifelse(FROMSELF, `abstract',
`define(`BCLASS', B`'CLASS)',
`define(`BCLASS', Bpy`'CLASS)

class BCLASS: public B`'CLASS, public VECLASS {
	ifdef(`VFUNS', `PyObject *vfn[NVFN];')
    public:
	dnl  Constructor(s):
	percomlist(CTORDCL)
ifdef(`VFUNS', `
	~`'BCLASS`'() {
                ifdef(`looperless',`//') getPyThread(looperspec(`Looper()'));
                unbindInstance();
                unbindSelf();
                ifdef(`looperless',`//') releasePyThread(looperspec(`Looper()'));
	}
	int bindInstance(PyInstanceObject *);
	PyObject *lookup(int i) {
		if (instance && i < NVFN)
			return vfn[i];
		else
			return 0;
	}
	list(VFNDCL)
')
};')

ifdef(`VFUNS', `
//  Set up Python/C++ peer (shadow?)
int
BCLASS::bindInstance(PyInstanceObject *inst)
{
	static struct vfnLookupTbl stdvfn[NVFN] = {
		vfms(VFUNS)
	};
	int count;
	ifelse(FROMSELF, `looper', `struct vfnLookupTbl lcfun = { 0, "lastchance" };
	count = VFNInventory(inst, &lastchancefun, &lcfun, 1);
	if (count < 0)
		return 0;', `count = 0;')
	count += VFNInventory(inst, vfn, stdvfn, NVFN);
	// if (count > 0)
	Py_INCREF(inst);
	return 1;
}
')


ifelse(FROMSELF, `looper',
`typedef LooperBaseObject PCLASS;',
`typedef BaseObject PCLASS;')

ifelse(FROMSELF, `looper',
`ifelse(CLASS, `Application',
`static void
`PyB'CLASS`'_dealloc(PCLASS *self)
{
}',

`static int
deleteThread(PyThreadState *tstate)
{
	PyThreadState_Clear(tstate);
	PyThreadState_Delete(tstate);
	return 1;
}

static void
`PyB'CLASS`'_dealloc(PCLASS *self)
{
	BCLASS *cobj;
	if (INTERNAL_BEPTR(self))
		cobj = (BCLASS *) self->bevoid;
	else
		cobj = 0;
	if (cobj && cobj->pystamp == BPYSTAMP) {
		cobj->pystamp = 0;
		PyThreadState *tstate = self->tstate;
		if (cobj && !self->sysref) {
			if (cobj->Lock())
				cobj->Quit();  // == delete cobj.
		}
		if (tstate) {
			//  End of the road for this thread.
			//  Would like to delete its state table.
			//  Cannot do this from same thread(?), but
			//  a pending call is OK.
			PyThreadState *cur = PyThreadState_Get();
			if (cur == tstate)
				Py_AddPendingCall((int (*)(ANY *)) deleteThread,
					(ANY *) tstate);
			else
				deleteThread(tstate);
		}
	}
	self->bevoidness = 0;
	PyMem_DEL(self);
}')',
`static void
PyB`'CLASS`'_dealloc(PCLASS *self)
{
	if (INTERNAL_BEPTR(self)) {
		BCLASS *cobj = (BCLASS *) self->bevoid;
		delete cobj;
	} ifelse(FROMSELF,`var', ` else {
		B`'CLASS *cobj = (B`'CLASS *) self->bevoid;
		delete cobj;
	}')
	self->bevoidness = 0;
	PyMem_DEL(self);
}')

//  cfunctions will be used to export the to/from functions, to other
//  Bxxx.so modules.

static struct BaseFunctions cfunctions;

typedef struct StringDx {
	char *ptr;
	int len;
} pstring;

static PyObject *
StatusError(const char *name, status_t stnum)
{
	static const char unknown[] = "(unknown)";
	char *r = strerror(stnum);
	if (!r)
		r = (char *) unknown;
	PyErr_SetObject(ECLASS, Py_BuildValue("ls", stnum, r));
	return 0;
}

static PyObject * PyB`'CLASS`'_simpleattr(BaseObject *, char *, PyObject *);
static B`'CLASS *
nativePtr(PCLASS *self)
{
	int i;
	for (i = 0; i < MAXBASETYPES && self->base[i].name[0]; ++i) {
		if (self->base[i].simpleattr == PyB`'CLASS`'_simpleattr)
			return (B`'CLASS *) ((void *) (((long) self->bevoid) + self->base[i].offset));
	}
	fprintf(stderr, "B`'CLASS not found.\n");
	return 0;
dnl	if (INTERNAL_BEPTR(self)) {
dnl		BCLASS *cobj = (BCLASS *) self->bevoid;
dnl		return (B`'CLASS *) cobj;
dnl	} else
dnl		return (B`'CLASS *) self->bevoid;
}
ifelse(FROMSELF, `looper',
   `define(`mkDerivative', `
	BCLASS *$2;
	if (!INTERNAL_BEPTR($1)) {
		PyErr_SetString(PyExc_SystemError, "Illegal operation on external object.");
		return 0;
	}
	$2 = (BCLASS *) ($1)->bevoid;')')

dnl  Bring in a bunch of generated sections:

include(CODEINCL)
include(FUNCINCL)
ifdef(`VFUNS',
`static PyObject *
PyB`'CLASS`'_bind(PCLASS *self, PyObject *arg)
{
	BCLASS *cobj;
	if (INTERNAL_BEPTR(self))
		cobj = (BCLASS *) self->bevoid;
	else
		cobj = 0;
	if (!arg) {
		PyObject *inst;
		if (cobj && cobj->frmpy())
			inst = (PyObject *) cobj->instance;
		else
			inst = 0;
		if (!inst)
			inst = Py_None;
		Py_INCREF(inst);
		return inst;
	}
	if (!cobj || !cobj->frmpy()) {
		PyErr_SetString(PyExc_ValueError,
			"operation not supported on externally referenced object");
		return 0;
	}
	if (arg == Py_None)
		cobj->unbindInstance();
	else {
		if (!PyInstance_Check(arg)) {
			PyErr_SetString(PyExc_TypeError,
				"bind requires 1 instance argument");
			return 0;
		}
		if (!cobj->bindInstance((PyInstanceObject *) arg))
			return 0;
	}
	Py_INCREF(Py_None);
	return Py_None;
}')

static struct PyMethodDef PyB`'CLASS`'_methods[] = {
	methods(METHODS)
	ifdef(`VFUNS', `{"bind",		(PyCFunction) PyB`'CLASS`'_bind},')
	{NULL,		NULL}		/* sentinel */
};

static PyObject *
PyB`'CLASS`'_simpleattr(BaseObject *obj, char *name, PyObject *qlist)
{
	PCLASS *self = (PCLASS *) obj;
	`B'CLASS *cobj;
	if (INTERNAL_BEPTR(self)) {
		BCLASS *dobj = (BCLASS *) self->bevoid;
		cobj = (`B'CLASS *) dobj;
	} else if (EXTERNAL_BEPTR(self))
		cobj = (`B'CLASS *) self->bevoid;
	else {
		PyErr_SetString(PyExc_SystemError, "Invalid object");
		return 0;
	}
	PyObject *ret;
	static char *attrs[] = {
		strings(ATTRIBUTES)
		0
	};

	if (qlist) {
		int i;
		for (i = 0; attrs[i]; ++i)
			PyList_Append(qlist, PyString_FromString(attrs[i]));
		return qlist;
	} else {
include(ATTRINCL)
		return Py_FindMethod(PyB`'CLASS`'_methods, (PyObject *) obj, name);
	}
}

static PyTypeObject PyB`'CLASS`'Type = {
	PyObject_HEAD_INIT(&PyType_Type)
	0,			/*ob_size*/
	"B`'CLASS",		/*tp_name*/
	sizeof(PCLASS),	/*tp_size*/
	0,			/*tp_itemsize*/
	/* methods */
	(destructor) PyB`'CLASS`'_dealloc, /*tp_dealloc*/
	0,			/*tp_print*/
	(getattrfunc) Base_getattr, /*tp_getattr*/
	0,			/*tp_setattr*/
	0,			/*tp_compare*/
	0,			/*tp_repr*/
};

static struct baseItem basemodules[MAXBASETYPES];

static void
initBases()
{
	static int initstate = 0;
	//  First of our kind?  
	if (initstate)
		return;
	memset(basemodules, 0, sizeof(basemodules));
	//  Need a non-null pointer value here, but cannot be sure
	//  that the first caller will have access to a properly
	//  constructed BCLASS.  Appears that any non-null value
	//  is as good as another, though.  If this is not true
	//  after all, we will have to put back in some code that
	//  comes back and cleans this up the first time a real
	//  BCLASS is available.
	BCLASS *derived = (BCLASS *) 0xdeadbeef;
	Base_init(basemodules, "B`'CLASS",
		(long) ((B`'CLASS *) derived) - (long) derived,
				PyB`'CLASS`'_simpleattr);
	bases(BASES)
	initstate = 1;
}

ifelse(FROMSELF,`abstract',,
`static PCLASS *
PyB`'CLASS`'_new()
{
	PCLASS *self;
	self = PyObject_NEW(PCLASS, &PyB`'CLASS`'Type);
	if (self) {
		self->bevoid = 0;
		self->bevoidness = 0;
		self->base = basemodules;
		ifelse(FROMSELF, `looper', `self->sysref = 0;
		self->tstate = PyThreadState_Get();')
	}
	return self;
}
')

ifdef(`PRESET',`static PCLASS *std`'PCLASS;')

static B`'CLASS`' *
PyB`'CLASS`'_AsB`'CLASS`'(PyObject *arg)
{

dnl	if (arg->ob_type != &PyB`'CLASS`'Type)
dnl		return 0;
dnl	return (B`'CLASS`' *) ((PyB`'CLASS`'Object *) arg)->cobj;
dnl  The present object may be of Python type B`'CLASS, or of a
dnl  derived class, and it suits our purposes to accept either.
dnl  So if it appears that it is at least of the BeOS type generally,
dnl  try to cast to B`'CLASS from the universal base.  dynamic_cast
dnl  is supposed to return 0 if that is not legit with this object,
dnl  but I seem unable to get that to work by trying various things
dnl  at random.  So, I grub through the Python base list, which is
dnl  not really the ideal notion of what we want.
dnl  I mean, the question really is whether the object is acceptably
dnl  derived per the Be API, not whether we happen to have a Python
dnl  implementation of the type with the nominally required relationship.
dnl
dnl  abstract classes used to return 0 here, not sure why!

	PyObject *stamped;
	if (arg->ob_type->tp_getattr)
		stamped = arg->ob_type->tp_getattr(arg, BEBOSTAMP);
	else
		stamped = 0;
	//  Correct response is None.
	if (stamped)
		Py_DECREF(stamped);
	if (!stamped || stamped != Py_None) {
		PyErr_SetString(PyExc_TypeError, "Not BeOS API object");
		return 0;
	}
	PyB`'CLASS`'Object *ob = (PyB`'CLASS`'Object *) arg;
	if (ob->ob_type != &PyB`'CLASS`'Type) {
		int i;
		for (i = 0; i < MAXBASETYPES && ob->base[i].name[0]; ++i) {
			// if (!strcmp(PyB`'CLASS`'Type.tp_name, ob->base[i].name))
			if (ob->base[i].simpleattr == &PyB`'CLASS`'_simpleattr)
				break;
		}
		if (i == MAXBASETYPES || !ob->base[i].name[0])
			return 0;
	}
	`B'CLASS *cobj;
	if (INTERNAL_BEPTR(ob)) {
		BCLASS *dobj = (BCLASS *) ob->bevoid;
		cobj = (`B'CLASS *) dobj;
	} else if (EXTERNAL_BEPTR(ob))
		cobj = (`B'CLASS *) ob->bevoid;
	else {
		PyErr_SetString(PyExc_SystemError, "Invalid object");
		return 0;
	}
	return cobj;
}

dnl  BStatable is an abstract class, for example.
dnl  be_app_messenger is a "preset", already instantiated.

ifelse(FROMSELF,`abstract',
`static PyObject *
PyB`'CLASS`'_FromB`'CLASS`'(const B`'CLASS`' *cobj)
{
	// Bogus function purely for standard cfunctions table.
	return 0;
}',FROMSELF,`var',
`static PyObject *
PyB`'CLASS`'_FromB`'CLASS`'(const B`'CLASS`' *cobj)
{
	if (!cobj) {
		PyErr_SetString(PyExc_ValueError, "null pointer");
		return 0;
	}
	PCLASS *self = PyB`'CLASS`'_new();
	if (self) {
		B`'CLASS *copy = new B`'CLASS`'((*(B`'CLASS`' *) cobj));
		SETEXT_BEPTR(self, copy);
		initBases();
	}
	return (PyObject *) self;
}',
`static PyObject *
PyB`'CLASS`'_FromB`'CLASS`'(B`'CLASS`' *cob)
{
	if (!cob) {
		PyErr_SetString(PyExc_ValueError, "null pointer");
		return 0;
	}
ifdef(`VFUNS',
  `define(`basecast',`dynamic_cast<$1>($2)')',
  `define(`basecast',`($1) $2')')
	BpyBase *dobj;
	dobj = basecast(`BpyBase *', `cob');
	if (dobj && dobj->frmpy()) {
		PyObject *self = dobj->self();
		Py_INCREF(self);
		return self;
	} else {
		PCLASS *self = PyB`'CLASS`'_new();
		if (self) {
			SETEXT_BEPTR(self, cob);
			initBases();
		}
		return (PyObject *) self;
	}
}')

static PyObject *module_dict;
include(GFUNCINCL)

static struct PyMethodDef B`'CLASS`'_global_methods[] = {
ifelse(FROMSELF,`abstract',,
`	{"B`'CLASS",	PyB`'CLASS`'_B`'CLASS, 1},')
	{NULL,		NULL}		/* sentinel */
};

#define set(s) PyDict_SetItemString(module_dict, #s, PyInt_FromLong(s))

`#'define preset(s,v) std`'PCLASS = PyB`'CLASS`'_new(); \
	SETEXT_BEPTR(std`'PCLASS, (void *) v); \
	initBases(); \
	PyDict_SetItemString(module_dict, `#'s, (PyObject *) std`'PCLASS);

extern "C" void
initB`'CLASS`'()
{
	PyObject *mod = Py_InitModule("B`'CLASS", B`'CLASS`'_global_methods);
	module_dict = PyModule_GetDict(mod);
	ECLASS = PyErr_NewException("B`'CLASS`'.error", 0, 0);
	PyDict_SetItemString(module_dict, "error", ECLASS);
ifdef(`PRESET', `	presets(PRESET)')
ifdef(`SYMBOLS', `	symbols(SYMBOLS)')
	cfunctions.simpleattr = PyB`'CLASS`'_simpleattr;
	cfunctions.AsIt = (void *(*)(PyObject *)) PyB`'CLASS`'_AsB`'CLASS;
	cfunctions.FromIt = (PyObject *(*)(const void *)) PyB`'CLASS`'_FromB`'CLASS;
	PyDict_SetItemString(module_dict, "functions", PyCObject_FromVoidPtr(&cfunctions, 0));
}
